package vn.azteam.tpf.service.dto;

import java.io.Serializable;
import java.util.Objects;
import io.github.jhipster.service.filter.BooleanFilter;
import io.github.jhipster.service.filter.DoubleFilter;
import io.github.jhipster.service.filter.Filter;
import io.github.jhipster.service.filter.FloatFilter;
import io.github.jhipster.service.filter.IntegerFilter;
import io.github.jhipster.service.filter.LongFilter;
import io.github.jhipster.service.filter.StringFilter;

/**
 * Criteria class for the TBCustomerHasCropType entity. This class is used in TBCustomerHasCropTypeResource to
 * receive all the possible filtering options from the Http GET request parameters.
 * For example the following could be a valid requests:
 * <code> /tb-customer-has-crop-types?id.greaterThan=5&amp;attr1.contains=something&amp;attr2.specified=false</code>
 * As Spring is unable to properly convert the types, unless specific {@link Filter} class are used, we need to use
 * fix type specific filters.
 */
public class TBCustomerHasCropTypeCriteria implements Serializable {

    private static final long serialVersionUID = 1L;

    private LongFilter id;

    private LongFilter tbCustomerId;

    private LongFilter tbActivityTypeId;

    private LongFilter tbCropTypeId;


    public LongFilter getId() {
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public LongFilter getTbCustomerId() {
        return tbCustomerId;
    }

    public void setTbCustomerId(LongFilter tbCustomerId) {
        this.tbCustomerId = tbCustomerId;
    }

    public LongFilter getTbActivityTypeId() {
        return tbActivityTypeId;
    }

    public void setTbActivityTypeId(LongFilter tbActivityTypeId) {
        this.tbActivityTypeId = tbActivityTypeId;
    }

    public LongFilter getTbCropTypeId() {
        return tbCropTypeId;
    }

    public void setTbCropTypeId(LongFilter tbCropTypeId) {
        this.tbCropTypeId = tbCropTypeId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TBCustomerHasCropTypeCriteria that = (TBCustomerHasCropTypeCriteria) o;
        return
            Objects.equals(id, that.id) &&
            Objects.equals(tbCustomerId, that.tbCustomerId) &&
            Objects.equals(tbActivityTypeId, that.tbActivityTypeId) &&
            Objects.equals(tbCropTypeId, that.tbCropTypeId) ;
    }

    @Override
    public int hashCode() {
        return Objects.hash(
        id,
        tbCustomerId,
        tbActivityTypeId,
        tbCropTypeId
        );
    }

    @Override
    public String toString() {
        return "TBCustomerHasCropTypeCriteria{" +
                (id != null ? "id=" + id + ", " : "") +
                (tbActivityTypeId != null ? "tbActivityTypeId=" + tbActivityTypeId + ", " : "") +
                (tbCropTypeId != null ? "tbCropTypeId=" + tbCropTypeId + ", " : "") +
                (tbCustomerId != null ? "tbCustomerId=" + tbCustomerId + ", " : "") +
            "}";
    }

}
